'-------------------------------------------------------------
'******* Titel      :   Perfmon Daten aus DB auslesen
'******* File Name  :   output_perfmon.vbs
'******* Datum      :   12.03.2007
'******* Author     :   Fabian Nf / nff
'******* Description:   Nimmt ber die Parameter entgegen, welche Daten abgeholt werden und gibt die Perfmon-Werte aus der DB zurck.
'-------------------------------------------------------------
'
' Version           :    1.0
' LetzteAenderung   :    12.03.2007
' LetzerAuthor      :    Fabian Nf / CKW
'-------------------------------------------------------------

' *** die bentigten Objekte werden initalisiert **
Set wshell = CreateObject("WScript.Shell")  						'SYS: Windows Script Host Runtime Library

' *** die wichtigsten Variablen werden deklariert ***
Dim strOutput(10)
Dim GUID


On Error Resume Next

If WScript.Arguments.Count = 0 Then
    Wscript.Echo "No argument on the command line." & vbCrLf & vbCrLf & "Syntax: output_perfmon.vbs CounterLogName"
Else

    ' *** Connect to DB ***
    Set objCONN = CreateObject("ADODB.Connection")

    objCONN.Open "Provider=SQLOLEDB.1;Data Source=SERVER;Initial Catalog=DBNAME;User Id=USER;Password=PASSWORD"

     ' *** Objekte zum Daten lesen erstellen ***
    Set objRS = CreateObject("ADODB.Recordset")
    Set objRS.ActiveConnection =objCONN
    Set objRS2 = CreateObject("ADODB.Recordset")
    Set objRS2.ActiveConnection =objCONN
    
    ' *** die Rckgabewerte Standardmssig auf 0 setzen ***
    For i = 0 To 9 Step 1
        strOutput(i) = 0
    Next
    
    ' *** von DisplayToID die GUID zum Counter Log abfragen ***
    strSQL = "SELECT GUID FROM DisplayToID WHERE DisplayString = '" & Wscript.Arguments(0) & "';"
    objRS.Open strSQL

    ' *** GUID in Variable schreiben ***
    GUID = objRS("GUID")
    
    ' *** RecordSet schliessen ***
    objRS.Close
    
    ' *** fr jede vorhandene CounterID von diesem CounterLog durchlaufen ***
    strSQL = "SELECT DISTINCT CounterID FROM CounterData WHERE GUID= '" & GUID & "';"
    objRS.Open strSQL
    
    ' *** i steht fr die Stelle im Array und startet bei 0 ***
    i = 0
    
    While Not objRS.EOF
    
        ' *** den CounterWert vom aktuellen Counter und CounterLog ...***
        strSQL2 = "SELECT CounterValue FROM CounterData WHERE GUID = '" & GUID & "' AND CounterID = " & objRS("CounterID") & " AND RecordIndex = (SELECT MAX(RecordIndex) FROM CounterData WHERE GUID = '" & GUID & "' AND CounterID = " & objRS("CounterID") & ");"

        objRS2.Open strSQL2
        
        ' *** ...im Array an Stelle "i" speicheren  ***
        strOutput(i) = objRS2("CounterValue")
        objRS2.Close
        
        ' *** zum nchsten Counter springen ***
        objRS.MoveNext
        
        ' *** i als Array- und Ausgabe- Stelle erhhen ***
        i = i + 1
    Wend
    objRS.Close

    ' *** Ausgabe aller Werte ***
    For i=1 To 8 Step 1
        strAusgabe = strAusgabe + "Value" & i & ":" & strOutput(i-1) & " "
    Next    
    Wscript.Echo strAusgabe
    
End If